function ranking_sales_partner (widget) {
    "use strict";

    var model= openerp;

    widget.RankingSalesPartnerWidget = widget.Base.extend({
        template: 'RankingSalesPartner',
        data : [],
        accountInvoice : [],
        resPartner : [],

        events: {
            'click canvas': 'showCustomers'
        },
        init: function (parent) {
            this._super(parent, {
                width : 6,
                height: 4
            });
        },
        start: function () {
            var self = this;
            self.fetchInitial();
        },
        fetchInitial:function(){
            var self = this;
            self.$el.block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.widget-content.widget-loading').css('display','flex');
            self.fecthInvoice().then(function (accountInvoice) {
                return accountInvoice;
            }).then(function (accountInvoice) {
                self.accountInvoice = accountInvoice;
                return self.fecthPartner(accountInvoice);
            }).then(function (resPartner) {
                self.resPartner = resPartner;
                return self.fetchProductRanking();
            });
        },
        // Obtener factura
        fecthInvoice: function(){
            var self = this;
            var desde =moment().format('YYYY-MM-01');
            var hasta =moment().add(1,'months').format('YYYY-MM-01');
            var defer = $.Deferred();
            var fields = ['id', 'invoice_line', 'date_invoice','partner_id'];
            var domain = [['type', '=', 'out_invoice'], ['date_invoice', '>=', desde], ['date_invoice', '<', hasta], ['state', '=', ['open','paid']]];
            var invoice = new model.web.Model('account.invoice');
            invoice.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        // Partner
        fecthPartner: function(invoice){
            var self = this;
            var defer = $.Deferred();
            var partner_id = _.map(invoice,function(map){
                return map.partner_id[0];
            });
            var fields =['id', 'name'];
            var domain =[['id', '=', partner_id],['active', '=', true],['customer','=',true]];
            var resPartner = new model.web.Model('res.partner');
            resPartner.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Obtener facturas por cada clientes
        getAccountInvoice:function(id_partner){
            var self = this;
            return _.flatten(_.filter(self.accountInvoice,function (inv) {
                return inv.partner_id[0] === id_partner;
            }));
        },
        fetchProductRanking: function(){
            var self = this;
            var itemPartner;
            var itemInvoice;
            var countInvoice = 0
            var ranking = [];

            for (var i = 0; i < self.resPartner.length; i++) {
                itemPartner = self.resPartner[i];
                itemInvoice = self.getAccountInvoice(itemPartner.id);
                countInvoice =_.countBy(_.map(itemInvoice,function(map){
                                    return map.id;
                                }),function(num){
                                    return num ? 'even': 'odd';
                                });
                ranking.push({ id : itemPartner.id,
                               name: itemPartner.name,
                               countInvoice :countInvoice.even
                           });
            }
            ranking.sort(function (a, b) {
                return b.countInvoice - a.countInvoice
            });
            self.ranking=ranking;

            self.$el.unblock();
            self.$el.find('.widget-content.widget-loading').css('display','none');
            self.$el.find('.widget-title').find('span').text("Ranking de Clientes Activos del Mes");
            self.fetchChart(ranking);
        },
        // Generar Grafico
        fetchChart: function (ranking){
            var self = this;
            var label = [];
            var body = [];
            var item;
            var rank = 10;

            for (var i = 0; i < rank; i++) {
                if (ranking[i]){
                    item = ranking[i];
                } else {
                    item = {};
                    item.name = "N/A";
                    item.countInvoice = 0;
                }
                label.push(item.name);
                body.push(item.countInvoice);
            }
            var chart = new Chart(this.$el.find(".widget-content").find('canvas'), {
                // type: 'doughnut',
                type: 'horizontalBar',
                // type: '',
                data: {
                    labels: label,
                    datasets: [
                        {
                            backgroundColor: ['#0288d1', '#0288d1', '#0288d1', '#0288d1', '#0288d1', '#0288d1', '#0288d1', '#0288d1', '#0288d1', '#0288d1'],
                            data: body,
                        }
                    ]
                },
                options: {
                    maintainAspectRatio: false,
                    layout: {
                        padding: 20
                    },
                    scales: {
                        xAxes: [{ stacked: true }],
                        yAxes: [{ stacked: true }],
                    },
                    legend: {
                        display: false,
                    },
                }
            });
        },

        showCustomers: function (e) {
            var self = this;
            var hoy =moment().format('YYYY-MM-DD');
            var partner_id= _.map(self.ranking,function(map){
                return map.id;
            })
            this.do_action({
                name:"Ranking de Clientes Activos del Mes",
                type: 'ir.actions.act_window',
                res_model: "res.partner",
                views: [[false, 'list']],
                target: 'new',
                domain: [['id', '=', partner_id]],
                context: {},
            });
        }
    });
}
